(**************************************************************************

     $RCSfile: Bullet.mod $
  Description: Interface to bullet.library

   Created by: fjc (Frank Copeland)
    $Revision: 3.6 $
      $Author: fjc $
        $Date: 1995/01/26 02:39:55 $

  $VER: bullet_protos.h 38.0 (19.6.92)
  Includes Release 40.15

  (C) Copyright 1990-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A Interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

*************************************************************************)

<* STANDARD- *> <* INITIALISE- *> <* MAIN- *>
<*$ CaseChk-  IndexChk- LongVars+ NilChk-  *>
<*$ RangeChk- StackChk- TypeChk-  OvflChk- *>

MODULE [2] Bullet;

IMPORT SYS := SYSTEM, Kernel, e := Exec, u := Utility, df := DiskFont;


(**-- Library Base variable --------------------------------------------*)

CONST

  bulletName * = "bullet.library";

VAR

  base* : e.LibraryPtr;


(**-- Library Functions ------------------------------------------------*)

PROCEDURE OpenEngine* [base,-30] ()
  : df.GlyphEnginePtr;
PROCEDURE CloseEngine* [base,-36]
  ( glyphEngine [8] : df.GlyphEnginePtr );
PROCEDURE SetInfoA* [base,-42]
  ( glyphEngine [8] : df.GlyphEnginePtr;
    tagList     [9] : ARRAY OF u.TagItem )
  : BOOLEAN;
PROCEDURE SetInfo* [base,-42]
  ( glyphEngine [8]  : df.GlyphEnginePtr;
    tagList     [9]..: u.Tag )
  : BOOLEAN;
PROCEDURE ObtainInfoA* [base,-48]
  ( glyphEngine [8] : df.GlyphEnginePtr;
    tagList     [9] : ARRAY OF u.TagItem )
  : BOOLEAN;
PROCEDURE ObtainInfo* [base,-48]
  ( glyphEngine [8]  : df.GlyphEnginePtr;
    tagList     [9]..: u.Tag )
  : BOOLEAN;
PROCEDURE ReleaseInfoA* [base,-54]
  ( glyphEngine [8] : df.GlyphEnginePtr;
    tagList     [9] : ARRAY OF u.TagItem )
  : BOOLEAN;
PROCEDURE ReleaseInfo* [base,-54]
  ( glyphEngine [8]  : df.GlyphEnginePtr;
    tagList     [9]..: u.Tag )
  : BOOLEAN;

(**-- Library Base variable --------------------------------------------*)

(**-----------------------------------*)
PROCEDURE* [0] CloseLib (VAR rc : LONGINT);

BEGIN (* CloseLib *)
  IF base # NIL THEN e.CloseLibrary (base) END
END CloseLib;

BEGIN
  base := e.OpenLibrary (bulletName, e.libraryMinimum);
  IF base # NIL THEN Kernel.SetCleanup (CloseLib) END
END Bullet.
