(***************************************************************************

     $RCSfile: GamePort.mod $
  Description: Interface to gameport.device

   Created by: fjc (Frank Copeland)
    $Revision: 3.7 $
      $Author: fjc $
        $Date: 1995/01/26 02:39:55 $

  $VER: gameport.h 36.1 (5.11.90)
  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

<* STANDARD- *> <* INITIALISE- *> <* MAIN- *>

MODULE [2] GamePort;

<*$ CaseChk-  IndexChk- LongVars+ NilChk-  *>
<*$ RangeChk- StackChk- TypeChk-  OvflChk- *>

IMPORT e := Exec, s := Sets;


(*
**      GamePort device command definitions
*)


CONST

(******  GamePort commands ******)
  readEvent     * = e.nonstd+0;
  askCType      * = e.nonstd+1;
  setCType      * = e.nonstd+2;
  askTrigger    * = e.nonstd+3;
  setTrigger    * = e.nonstd+4;

(******  GamePort structures ******)

(* GamePortTrigger.keys *)
  downKeys     * = 0;
  upKeys       * = 1;

TYPE

  GamePortTriggerPtr * = POINTER TO GamePortTrigger;
  GamePortTrigger * = RECORD
    keys *    : s.SET16;      (* key transition triggers *)
    timeout * : e.UWORD;      (* time trigger (vertical blank units) *)
    xDelta *  : e.UWORD;      (* X distance trigger *)
    yDelta *  : e.UWORD;      (* Y distance trigger *)
  END; (* GamePortTrigger *)

CONST

(****** Controller Types ******)
  allocated    * = -1;    (* allocated by another user *)
  noController * = 0;

  mouse        * = 1;
  relJoystick  * = 2;
  absJoystick  * = 3;


(****** Errors ******)
  errSetCType    * = 1;     (* this controller not valid at this time *)

END GamePort.
