(**************************************************************************

     $RCSfile: Icon.mod $
  Description: Interface to icon.library

   Created by: fjc (Frank Copeland)
    $Revision: 3.7 $
      $Author: fjc $
        $Date: 1995/01/26 02:39:55 $

  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

<* STANDARD- *> <* INITIALISE- *> <* MAIN- *>
<*$ CaseChk-  IndexChk- LongVars+ NilChk-  *>
<*$ RangeChk- StackChk- TypeChk-  OvflChk- *>

MODULE [2] Icon;

IMPORT SYS := SYSTEM, Kernel, e := Exec, w := Workbench;

(*
**      $VER: icon.h 36.1 (26.10.90)
**
**      external declarations for icon.library
*)

CONST

  iconName * = "icon.library";

VAR

  base * : e.LibraryPtr;


(*-- Library Functions ------------------------------------------------*)

(*
**      $VER: icon_protos.h 38.2 (16.6.93)
*)

PROCEDURE GetIcon* [base,-42]
  ( name      [8] : ARRAY OF CHAR;
    icon      [9] : w.DiskObjectPtr;
    freelist [10] : w.FreeListPtr )
  : LONGINT;
PROCEDURE PutIcon* [base,-48]
  ( name [8] : ARRAY OF CHAR;
    icon [9] : w.DiskObjectPtr )
  : BOOLEAN;
PROCEDURE FreeFreeList* [base,-54]
  ( freelist [8] : w.FreeListPtr );
PROCEDURE AddFreeList* [base,-72]
  ( freelist [8] : w.FreeListPtr;
    mem      [9] : e.APTR;
    size    [10] : e.ULONG )
  : BOOLEAN;
PROCEDURE GetDiskObject* [base,-78]
  ( name [8] : ARRAY OF CHAR )
  : w.DiskObjectPtr;
PROCEDURE PutDiskObject* [base,-84]
  ( name    [8] : ARRAY OF CHAR;
    diskobj [9] : w.DiskObjectPtr )
  : BOOLEAN;
PROCEDURE FreeDiskObject* [base,-90]
  ( diskobj [8] : w.DiskObjectPtr );
PROCEDURE FindToolType* [base,-96]
  ( toolTypeArray [8] : e.APTR;
    typeName      [9] : ARRAY OF CHAR )
  : e.LSTRPTR;
PROCEDURE MatchToolValue* [base,-102]
  ( typeString [8] : ARRAY OF CHAR;
    value      [9] : ARRAY OF CHAR )
  : BOOLEAN;
PROCEDURE BumpRevision* [base,-108]
  ( VAR newname [8] : ARRAY OF CHAR;
    oldname     [9] : ARRAY OF CHAR );

(* --- functions in V36 or higher (distributed as Release 2.0) ---*)

PROCEDURE GetDefDiskObject* [base,-120]
  ( type [0] : LONGINT )
  : w.DiskObjectPtr;
PROCEDURE PutDefDiskObject* [base,-126]
  ( diskObject [8] : w.DiskObjectPtr )
  : BOOLEAN;
PROCEDURE GetDiskObjectNew* [base,-132]
  ( name [8] : ARRAY OF CHAR )
  : w.DiskObjectPtr;
PROCEDURE DeleteDiskObject* [base,-138]
  ( name [8] : ARRAY OF CHAR )
  : BOOLEAN;

(*-- Library Base variable --------------------------------------------*)

<*$LongVars-*>

(*-----------------------------------*)
PROCEDURE* [0] CloseLib (VAR rc : LONGINT);

BEGIN (* CloseLib *)
  IF base # NIL THEN e.CloseLibrary (base) END
END CloseLib;

BEGIN
  base := e.OpenLibrary (iconName, e.libraryMinimum);
  IF base = NIL THEN HALT (100) END;
  Kernel.SetCleanup (CloseLib)
END Icon.
