(**************************************************************************

     $RCSfile: MathIEEESingTrans.mod $
  Description: Interface to mathieeesingtrans.library

   Created by: fjc (Frank Copeland)
    $Revision: 3.7 $
      $Author: fjc $
        $Date: 1995/01/26 02:39:55 $

  $VER: mathieeesingtrans_protos.h 1.3 (7.11.90)
  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

<* STANDARD- *> <* INITIALISE- *> <* MAIN- *>
<*$ CaseChk-  IndexChk- LongVars+ NilChk-  *>
<*$ RangeChk- StackChk- TypeChk-  OvflChk- *>

MODULE [2] MathIEEESingTrans;

IMPORT SYS := SYSTEM, Kernel, e := Exec, m := MathLibrary;


(*-- MathIEEESingTrans Base variable --------------------------------------*)

CONST

  mathIEEESingTransName * = "mathieeesingtrans.library";

VAR

  base * : m.MathIEEEBasePtr;


(*-- Library Functions ------------------------------------------------*)

PROCEDURE Atan* [base,-30]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Sin* [base,-36]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Cos* [base,-42]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Tan* [base,-48]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Sincos* [base,-54]
  ( VAR cos[8] : REAL;
    parm [0]   : REAL )
   : REAL;

PROCEDURE Sinh* [base,-60]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Cosh* [base,-66]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Tanh* [base,-72]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Exp* [base,-78]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Log* [base,-84]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Pow* [base,-90]
  ( exp  [1] : REAL;
    parm [0] : REAL )
  : REAL;

PROCEDURE Sqrt* [base,-96]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Tieee* [base,-102]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Fieee* [base,-108]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Asin* [base,-114]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Acos* [base,-120]
  ( parm [0] : REAL )
  : REAL;

PROCEDURE Log10* [base,-126]
  ( parm [0] : REAL )
  : REAL;

(*-- Library Base variable --------------------------------------------*)

<*$LongVars-*>

(*-----------------------------------*)
PROCEDURE* [0] CloseLib (VAR rc : LONGINT);

BEGIN (* CloseLib *)
  IF base # NIL THEN e.CloseLibrary (base) END;
END CloseLib;

(*-----------------------------------*)
PROCEDURE [0] OpenLib * (mustOpen : BOOLEAN);

BEGIN (* OpenLib *)
  IF base = NIL THEN
  END;
END OpenLib;

BEGIN
  base := SYS.VAL(m.MathIEEEBasePtr,
                  e.OpenLibrary (mathIEEESingTransName, e.libraryMinimum));
  IF base = NIL THEN HALT (100) END;
  Kernel.SetCleanup (CloseLib)
END MathIEEESingTrans.
